=== modified file 'bzrlib/commands.py'
--- bzrlib/commands.py	2005-07-11 06:41:00 +0000
+++ bzrlib/commands.py	2005-07-11 07:25:42 +0000
@@ -1424,8 +1424,15 @@
     hidden = True
     def run(self):
         import bzrlib.plugin
+        from inspect import getdoc
         from pprint import pprint
-        pprint(bzrlib.plugin.all_plugins)
+        for plugin in bzrlib.plugin.all_plugins:
+            print plugin.__path__[0]
+            d = getdoc(plugin)
+            if d:
+                print '\t', d.split('\n')[0]
+
+        #pprint(bzrlib.plugin.all_plugins)
 
 
 

=== modified file 'bzrlib/plugin.py'
--- bzrlib/plugin.py	2005-06-28 03:02:31 +0000
+++ bzrlib/plugin.py	2005-07-11 07:25:42 +0000
@@ -114,7 +114,7 @@
                 try:
                     plugin = imp.load_module('bzrlib.plugin.' + name,
                                              *plugin_info)
-                    all_plugins.append(plugin_info)
+                    all_plugins.append(plugin)
                 finally:
                     if plugin_info[0] is not None:
                         plugin_info[0].close()

=== modified file 'bzrlib/selftest/__init__.py'
--- bzrlib/selftest/__init__.py	2005-07-11 07:05:34 +0000
+++ bzrlib/selftest/__init__.py	2005-07-11 07:25:42 +0000
@@ -23,7 +23,7 @@
 def selftest():
     from unittest import TestLoader, TestSuite
     import bzrlib, bzrlib.store, bzrlib.inventory, bzrlib.branch
-    import bzrlib.osutils, bzrlib.commands, bzrlib.merge3
+    import bzrlib.osutils, bzrlib.commands, bzrlib.merge3, bzrlib.plugin
     global MODULES_TO_TEST, MODULES_TO_DOCTEST
 
     import bzrlib.selftest.whitebox
@@ -78,6 +78,10 @@
     for m in (MODULES_TO_DOCTEST):
         suite.addTest(DocTestSuite(m))
 
+    for p in bzrlib.plugin.all_plugins:
+        if hasattr(p, 'test_suite'):
+            suite.addTest(p.test_suite())
+
     suite.addTest(unittest.makeSuite(bzrlib.merge_core.MergeTest, 'test_'))
 
     return run_suite(suite, 'testbzr')

